;========================================================
;GENERAL DATA
;========================================================
;(lots of wasted spaced, but the file's not huge anyhow)

StringBuffer	    db	    512 dup 0	  ;storage for EXE name and root Trespasser folder (faster if static)
PathStringSize	    dd	    0
MapsDirBuffer	    db	    512 dup 0	  ;root Trespasser folder + 'MAPS\' subfolder
MapsPathSize	    dd	    0
DDF_FN_Buffer	    db	    512 dup 0	  ;used for DDF (same as MapsDirBuffer)
ATXconfiginiFN	    db	    512 dup 0	  ;full ATXconfig.ini filename and path

_integer	    dd	    "%i",0	  ;for MSVCRT calls (if present)
_float		    dd	    "%f",0
_unint		    dd	    "%u",0

WindowName	    db	    'Trespasser',0
WindowClassName     db	    'DWI - Trespasser',0

SAVEGAME_STRING     db	    'SAVEGAME.*',0

system_info_buf     SYSTEM_INFO

ATX_title_main	    db	    'ATX Exit Error',0
ATX_rv_warning	    db	    'Warning! Video recording halted prematurely.',0Dh,0Ah
		    db	    'Please restart your computer.',0

;========================================================
include 'Errors.inc'
;========================================================

CAnimal_BUF	    dd	    0		  ;holds pointers to all CAnimal objects
CAnimal_BUF_SIZE    dd	    0		  ;size of previous buffer and INDEX buffer
New_CAnimal_BUF     db	    1

CAnimal_Names_INDEX	    dd	    0	  ;list of pointers into next buffer for strings
CAnimal_Names_BUF	    dd	    0
CAnimal_Names_BUF_SIZE	    dd	    0
CAnimal_Initial_Info	    dd	    0

CAnimal_JUMP_Info_BUF	    dd	    0

;NewLevel_BOOL               db      1
Restart_Exit_Level_BOOL     db	    0

ATXCONFIGFN		    db	    "ATXconfig.ini",0

TempMessageTime 	    dd	    0
TempMessageString	    dd	    0
TempMessageParam1	    dd	    0
TempMessageParam2	    dd	    0
TempMessageParam3	    dd	    0
TempMessageParam4	    dd	    0

;========================================================
;DirectDraw data
;========================================================
PrimarySurfaceDC	dd	0
PrimarySurfaceObj	dd	0
Effects_BOOL		dd	0	;bit0 = effect1, bit1 = n/a

lpDDBltFx		DDBLTFX
;DDSurface_Temp          DDSURFACEDESC2

;========================================================
;dino location randomizing values
;========================================================
NULL_STRING		db	"NULL",0
ZERO_STRING		db	"0",0
FLOAT_RETRIEVE_STRING	db	"%f, %f, %f",0
MAIN_SECTION		db	"Instances",0
ENTRIES_STRING		db	"Entries",0
ENTRY_COUNT		db	"NumberOfENTRYSections",0
INSTANCE_STRING 	db	"Instance%u",0
RESERVE_STRING		db	"Reserve%u",0
ENTRY_STRING		db	"ENTRY%u",0
LOCATION_STRING 	db	"Location%u",0
STAYNEARMAX_STRING	db	"ForceStayNearMax",0
STAYNEAROK_STRING	db	"ForceStayNearOK",0
WAKEUP_STRING		db	"ForceWakeUp",0
SLEEP_STRING		db	"ForceSleep",0
NOGETOUT_STRING 	db	"DisableActGetOut",0

RAND_BUF1		db	50 dup 0
RAND_RSRV_ENTRY_BUF	db	50 dup 0
RAND_INST_NAME_BUF	db	50 dup 0
RAND_LOC_STR_BUF	db	50 dup 0
;========================================================
;CANIMAL cheat data
;========================================================
canimal_title_base	db	"CAnimal Info (%u instances):",0
canimal_title_size	dd	0
canimal_title		db	55 dup 0
canimal_base_addr	db	"Base Address: 0x%.8X",0
canimal_pos		db	"Location: %.2f, %.2f, %.2f",0
canimal_health		db	"HitPoints: %.2f",0
canimal_maxhealth	db	"MaxHitPoints: %.2f",0
canimal_bravery 	db	"Bravery: %.5f",0
canimal_jumpinfo	db	"ActJumpNew info: %.2f, %.2f, %u, %u, %u",0

canimal_emos_text_table:
	dd canimal_fear,canimal_love,canimal_anger,canimal_curiosity
	dd canimal_hunger,canimal_thirst,canimal_fatigue,canimal_pain
canimal_emos_text_table_end:

canimal_emos_offsets_table:	   ;offsets from main AI class
	dd 4h,8h,0Ch,10h
	dd 14h,18h,1Ch,20h

canimal_anger		db	"Anger: %.5f",0
canimal_curiosity	db	"Curiosity: %.5f",0
canimal_fatigue 	db	"Fatigue: %.5f",0
canimal_fear		db	"Fear: %.5f",0
canimal_hunger		db	"Hunger: %.5f",0
canimal_love		db	"Love: %.5f",0
canimal_thirst		db	"Thirst: %.5f",0
canimal_pain		db	"Pain: %.5f",0

DisplayDinoInfo_BOOL	db	0
DisplayDino_INDEX	dd	0
ShowPlayerHealth_BOOL	db	0

ShowDinosOnMap_BOOL		db	0
ShowActiveDinoOnMap_BOOL	db	0

ShowFaceFloats_BOOL		db	0
ShowFaceFloat_STRING		db	"Player face values (wxyz): %.3f, %.3f, %.3f, %.3f",0
ShowFaceFloat_AA_STRING 	db	"Angle (rad) & Axis (xyz): %.3f, %.3f, %.3f, %.3f",0
ShowPlayerHealth_STRING 	db	"Player HitPoints & MaxHitPoints: %.5f, %.5f",0

;========================================================
;MAP cheat data
;========================================================
MapIndex		    db	    "MapIndex.ini",0
STRING_Bitmap		    db	    "Bitmap",0
STRING_BMPDEF		    db	    "DEF",0
STRING_X1		    db	    "X1",0
STRING_Y1		    db	    "Y1",0
STRING_X2		    db	    "X2",0
STRING_Y2		    db	    "Y2",0
BMPMAPNAME_BUF		    db	    150 dup 0

;========================================================
;other
;========================================================


;FLAGS/VALUES
UseMXTBITE		    dd	    0
UseWINDOWED		    dd	    0
UseGRAVITY		    dd	    0
UseDRAWDISTANCE 	    dd	    0
UseTRESSTRDBG		    dd	    0
UseDEMOHACK		    dd	    0
UseNoGetOut		    dd	    0
UseNoStayNear		    dd	    0
UseNoStayAway		    dd	    0
UseSleepWake		    dd	    0
UseDisableSWPDelete	    dd	    0
UseCAnimalHitPoints	    dd	    0
UseRandomDinoLocations	    dd	    0
UseDisableActJumpNew	    dd	    0
UseForceActDrink	    dd	    0

UseUserMapKey		    dd	    0
UseUserMDinoKey 	    dd	    0
UseDrawDistSubKey	    dd	    0
UseDrawDistAddKey	    dd	    0
UseCANIMALKey		    dd	    0
UseUserMSelKey		    dd	    0
UseUserCANIMALLEFTKey	    dd	    0
UseUserCANIMALRIGHTKey	    dd	    0
UseMXTRadius		    dd	    0

UseToggleNewKeys	    dd	    0
ToggleNewKeys_BOOL	    db	    1
ToggleKeys_FORCED_BOOL	    db	    0
ToggleKeysShowStateTime     dd	    0

;troubleshooting
UseDisableA3Ddll	    dd	    0
UseHighResolutionsHack	    dd	    0

SDBGDUMPFILE		    db	    "C:\SDBG_DUMP.txt",0

RT_ERROR_COUNT		    dd	    0
LAST_ERROR_TIME 	    dd	    0
ErrorCountDisplayString     db	    "ATXTres Error Detected (Total: %u)",0

FPS_framecount		    dd	    0
FPS_lastframetime	    dd	    0
FPS_toggle		    db	    0
FPS_string		    db	    "FPS: %.2f",0
FPS_lastfps		    dq	    0

;========================================================
;VARIOUS STORED FLOATS
;========================================================

align 4
float_0 		dd	0.000000
float_two		dd	2.000000
float_one		dd	1.000000
float_0_5		dd	0.500000
float_0_5_B		dd	0.500000
pidivtwo		dd	1.5707963267948966192313216916398
pi			dd	3.1415926535897932384626433832795
pidiv180		dd	0.0174532925199432957692369076848861
d180divpi		dd	57.2957795130823208767981548141052
float_100		dd	100.000000
float_15		dd	15.000000
float_1000		dd	1000.000000
float_0_001		dd	0.001000
float_0_0005		dd	0.0005

;========================================================
;ActionType data
;========================================================

;AT100
LastTimerID	    dd	    0		  ;used to remember last set timer

;AT102
AT102EMULATEDOBJECT:
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    1	;1 for direct BMP name ref (not relative to buffer)

;current bitmap values /*
anchorXvalue	    dd	    0
anchorYvalue	    dd	    0
scaleXvalue	    dd	    0
scaleYvalue	    dd	    0

currentbitmap	    dd	    0
bitmapheight	    dd	    0
bitmapwidth	    dd	    0
;                       */

USE_MAP 	    db	    0
USE_LOC 	    db	    0
LastTickCount	    dd	    0
Show_Blinker	    db	    1

SAVED_MAP_BUFFER    db	    80 dup 0

CURRENT_MAP_BUFFER  db	    80 dup 0
CURRENT_MAP_VALUES  dd	    4 dup 0

SAVEGAMENAME_BUFFER  db     256 dup 0

SAVED_MAP_OBJECT:
		    dd	    0
		    dd	    0
		    dd	    SAVED_MAP_BUFFER
SAVED_MAP_X1	    dd	    0
SAVED_MAP_Y1	    dd	    0
SAVED_MAP_X2	    dd	    0
SAVED_MAP_Y2	    dd	    0
		    dd	    1		;1 for direct BMP name ref

IsInGame_BOOL			db	0
IsInConsole_BOOL		db	0

DrawDistDisplayTime		dd	0
DrawDistDisplayString		db	"Draw Distance: %2f",0

;========================================================
;counter data
;========================================================
CounterFirstRun     dd	    0
USE_COUNTER	    dd	    0
FirstTimeStamp	    dd	    0
Time_Format_String  db	    "Time: %-.2u:%-.2u:%-.2u",0

;========================================================
;MXTBITE data
;========================================================

AT100SimulatedObject:
		    dd	    0
		    dd	    0
DefaultSlowSpeed    dd	    0
DefaultInterval     dd	    0
		    dd	    0
		    dd	    0

NormalGameSpeed     dd	    0	 ;updated with variable from executable or INI and/or ActionType 100-101

;========================================================
;HACKED CONSOLE VARIABLES
;========================================================

STRING_LOC		    db	"LOC",0
STRING_DINOS		    db	"DINOS",0
STRING_BIONICWOMAN	    db	"BIONICWOMAN",0
STRING_INVUL		    db	"INVUL",0
STRING_WOO		    db	"WOO",0

Cheattable:
       times ((EndNewCheattableMembers-NewCheattableMembers)+DEFAULT_CHEAT_ENTRY_COUNT*8) db 0

STRING_MAP		    db	"MAP",0
STRING_TIME		    db	"TIME",0
STRING_RESET		    db	"RESET",0
STRING_DINOINFO 	    db	"CANIMAL",0
STRING_DINOINFOCYCLELEFT    db	"B",0
STRING_DINOINFOCYCLERIGHT   db	"N",0
STRING_KILLDINO 	    db	"KILL",0
STRING_MDINO		    db	"MDINO",0
STRING_MSEL		    db	"MSEL",0
STRING_HEALDINO 	    db	"HEALDINO",0
STRING_TESTCHEAT	    db	"TEST",0
STRING_CLOAK		    db	"CLOAK",0
STRING_FAC		    db	"FAC",0
STRING_FLY		    db	"FLY",0
STRING_KILLALL		    db	"KILLALL",0
STRING_TELEDINO 	    db	"TELEDINO",0
STRING_REC		    db	"REC",0
STRING_PLAYERHEALTH	    db	"PLAYERHEALTH",0
STRING_FPS		    db	"FPS",0
STRING_SUPERHP		    db	"SUPERHP",0
STRING_NORMALHP 	    db	"NORMALHP",0
STRING_SHOWDD		    db	"SHOWDD",0
STRING_CTFRATE		    db	"CTFRATE",0
STRING_KEYRATE		    db	"KEYRATE",0

MACRO DEFINE_CHEAT cheat1 {
      dd cheat1
      dd 0
      }

NewCheattableMembers:
	DEFINE_CHEAT	  STRING_MAP
	DEFINE_CHEAT	  STRING_TIME
	DEFINE_CHEAT	  STRING_RESET
	DEFINE_CHEAT	  STRING_DINOINFO
	DEFINE_CHEAT	  STRING_DINOINFOCYCLELEFT
	DEFINE_CHEAT	  STRING_DINOINFOCYCLERIGHT
	DEFINE_CHEAT	  STRING_KILLDINO
	DEFINE_CHEAT	  STRING_MDINO
	DEFINE_CHEAT	  STRING_MSEL
	DEFINE_CHEAT	  STRING_HEALDINO
	DEFINE_CHEAT	  STRING_TESTCHEAT
	DEFINE_CHEAT	  STRING_CLOAK
	DEFINE_CHEAT	  STRING_FAC
	DEFINE_CHEAT	  STRING_FLY
	DEFINE_CHEAT	  STRING_KILLALL
	DEFINE_CHEAT	  STRING_TELEDINO
	DEFINE_CHEAT	  STRING_REC
	DEFINE_CHEAT	  STRING_PLAYERHEALTH
	DEFINE_CHEAT	  STRING_FPS
	DEFINE_CHEAT	  STRING_SUPERHP
	DEFINE_CHEAT	  STRING_NORMALHP
	DEFINE_CHEAT	  STRING_SHOWDD
	DEFINE_CHEAT	  STRING_CTFRATE
	DEFINE_CHEAT	  STRING_KEYRATE
EndNewCheattableMembers:

CHEATJUMPINDEX:
	times ((ENDNEWCHEATSINDEX-NEWCHEATSINDEX)+DEFAULT_CHEAT_ENTRY_COUNT*4)	db	0

NEWCHEATSINDEX:
	dd	DISPLAYMAPCONSOLE
	dd	DISPLAYCOUNTER
	dd	RESETCOUNTER
	dd	DISPLAYDINOINFO
	dd	CYCLEDINOINFOLEFT
	dd	CYCLEDINOINFORIGHT
	dd	KILLACTIVEDINO
	dd	SHOWDINOSONMAP
	dd	SHOWACTIVEDINOONMAP
	dd	HEALACTIVEDINO
	dd	TESTCHEATCODE
	dd	CHANGEPLAYERTYPE
	dd	SHOWPLAYERFACEFLOATS
	dd	ENABLEFLYCHEAT
	dd	KILLALLDINOS
	dd	TELEPORTDINOCHEAT
	dd	VIDEOCAPTURETOGGLE
	dd	SHOWPLAYERHEALTH
	dd	TOGGLEFPSDISPLAY
	dd	SETHIGHHPVALUE
	dd	SETNORMALHPVALUE
	dd	SHOWTEMPDRAWDIST_CHEAT
	dd	TOGGLECTFRATEDISPLAY
	dd	TOGGLEKEYRATEDISPLAY
ENDNEWCHEATSINDEX:

TotalCheats	dd	0
OriginalCheats	dd	0

;========================================================
;FLY MODE VALUES/VARS
;========================================================

UseFlySpeed		dd	0
UseFlyKeyDelay		dd	0
UseFlyKeyDelay_RECIPR	dd	0

FlySpeedTemp		dd	0
FlySpeedTemp_Fast	dd	0

FLY_MODE_BOOL		db	0
Key_Last_Recorded_Time	dd	0

LastXPostion_FLY	dd	0	;only these need to be updated
LastYPostion_FLY	dd	0	;when cheat is enabled
LastZPostion_FLY	dd	0

Temp_Fly_Buffer 	dd	8 dup 0    ;3 position values, 4 for quats, 1 for bools
Temp_Fly_Buffer2	dd	3 dup 0
Temp_Fly_Buffer3:
	dd 0
	dd 03F800000h
	dd 0

DefaultKeyBOOLS:	;from "KeyMap" reg key/exe key list
	dd	00000040h
	dd	00000080h
	dd	00000010h
	dd	00000008h
	dd	00000020h
	dd	00000001h
	dd	00000002h
	dd	00000100h
	dd	00000400h
	dd	00000200h
	dd	01000000h
	dd	02000000h
	dd	04000000h
	dd	08000000h
	dd	10000000h
DefaultKeyBOOLS_END:

;========================================================
;DINO JUMP DATA/BUFFERS
;========================================================
AT10_SIM_OBJECT       db	(64+16) dup 0	  ;VTable set in INI init code include fil

AT10_EMITTER_SIM_OBJECT db	100 dup 0

STRING_GENERAL		db	"General",0
STRING_PUSH		db	"Push",0
STRING_JUMPANGLE	db	"JumpAngle",0
STRING_JUMPTENDANCY	db	"JumpTendancy",0
STRING_REPEATPERIOD	db	"RepeatPeriod",0

;default values
Push_INIdef		db	50 dup 0
JumpAngle_INIdef	db	50 dup 0
JumpTendancy_INIdef	dd	0
RepeatPeriod_INIdef	dd	0

;storage default values
Push_default		db	50 dup 0
JumpAngle_default	db	50 dup 0
JumpTendancy_default	dd	0
RepeatPeriod_default	dd	0

;========================================================
;MENU AND GAME DIFFICULTY DATA
;========================================================

GameDifficultyValue		dd	2
SLIDER_METHOD_TRUE		dd	0
BUTTON_METHOD_TRUE		dd	0
CHECKBOX_METHOD_TRUE		dd	0
HOTSPOT_METHOD_TRUE		dd	0
CHECKBOX_MATRIX_OBJ		dd	0
CHECKBOX_JUMP_DINOS_OBJ 	dd	0
CHECKBOX_RANDOM_DINOS_OBJ	dd	0
MAINSCREEN_DDF_RET_ADDR 	dd	0
MAINSCREEN_TEMP_FILE_NAMEONLY	db	'mainscreen.ddf',0
RENDER_TEMP_FILE_NAMEONLY	db	'render.ddf',0
FLOAT_PRINT_SIX_DEC		db	"%.6f",0

;========================================================
;mainscreen.ddf additions
;========================================================

UseNewMenuItems 	 dd	 0

NEW_MENU_DATA_BUFFER:
db 0Dh,0Ah,0Dh,0Ah

;-----------------------
;Game difficulty text
;-----------------------
db 'UICTRL "textbox" 1 1 -1 482 260 622 275',0Dh,0Ah
db '        1                      ',0Dh,0Ah		     ; Transparent Bk
db '        1                      ',0Dh,0Ah		     ; Back Lit
db '        1                      ',0Dh,0Ah		     ; Back lit offset
db '        0 0 0                  ',0Dh,0Ah		     ; Back lit color
db '        "Game Difficulty"      ',0Dh,0Ah		     ; Initial Text
db '        12                     ',0Dh,0Ah		     ; Point Size
db '        500                    ',0Dh,0Ah		     ; Weight
db '        0 255 0                ',0Dh,0Ah		     ; Bk Color
db '        255 255 255            ',0Dh,0Ah		     ; FG Color
db '        0x0                    ',0Dh,0Ah		     ; DT Flags
db '        0                      ',0Dh,0Ah		     ; Draw Border
db 0Dh,0Ah

db 'UICTRL "textbox" 1 1 -1 440 280 610 290',0Dh,0Ah
db '        1                      ',0Dh,0Ah		     ; Transparent Bk
db '        1                      ',0Dh,0Ah		     ; Back Lit
db '        1                      ',0Dh,0Ah		     ; Back lit offset
db '        0 0 0                  ',0Dh,0Ah		     ; Back lit color
db '        "Very Easy     Easy      Normal      Hard    Very Hard"      ',0Dh,0Ah		   ; Initial Text
db '        8                      ',0Dh,0Ah		     ; Point Size
db '        500                    ',0Dh,0Ah		     ; Weight
db '        0 255 0                ',0Dh,0Ah		     ; Bk Color
db '        255 255 255            ',0Dh,0Ah		     ; FG Color
db '        0x0                    ',0Dh,0Ah		     ; DT Flags
db '        0                      ',0Dh,0Ah		     ; Draw Border
db 0Dh,0Ah

;Gutter for difficulty slider (background image)
db 'UICTRL "static" 1 1 -1 450 300 -1 -1',0Dh,0Ah
db '        1 "menu\\gutter_150.tga"  ',0Dh,0Ah
db 0Dh,0Ah

;Game difficulty slider (width=146, height=14)
db 'UICTRL "slider" 1 1 1956 452 295 598 309',0Dh,0Ah		 ;1956 -> used to ID slider
db '        "menu\\slider.tga"     ',0Dh,0Ah
db '        5                      ',0Dh,0Ah		     ; # of units
db '        '
   Default_GSPD_Slider_Unit_Value:
db	   '0                      ',0Dh,0Ah		     ; Default Unit value
db '        0                      ',0Dh,0Ah		     ; Border/Ticks
db 0Dh,0Ah

;-----------------------
;ATX version ID
;-----------------------
db 'UICTRL "textbox" 1 1 -1 500 0 600 20',0Dh,0Ah
db '        1                      ',0Dh,0Ah		     ; Transparent Bk
db '        1                      ',0Dh,0Ah		     ; Back Lit
db '        1                      ',0Dh,0Ah		     ; Back lit offset
db '        0 0 0                  ',0Dh,0Ah		     ; Back lit color
db '        "ATX v',ATX_VERSION,' BETA" ',0Dh,0Ah		  ; Initial Text
db '        12                     ',0Dh,0Ah		     ; Point Size
db '        500                    ',0Dh,0Ah		     ; Weight
db '        0 255 0                ',0Dh,0Ah		     ; Bk Color
db '        255 255 255            ',0Dh,0Ah		     ; FG Color
db '        0x0                    ',0Dh,0Ah		     ; DT Flags
db '        0                      ',0Dh,0Ah		     ; Draw Border
db 0Dh,0Ah

;CHECKBOX: width = -50 , height = +15

;-----------------------
;Matrix checkbox        (1rst from top)
;-----------------------
db 'UICTRL "checkbox" 1 1 1869 455 325 405 340',0Dh,0Ah
db '        "menu\\check_0.tga"       ',0Dh,0Ah
db '        "menu\\check_1.tga"       ',0Dh,0Ah
db '        "menu\\check_2.tga"       ',0Dh,0Ah
db '        "menu\\check_3.tga"       ',0Dh,0Ah
db 0Dh,0Ah

;Matrix text
db 'UICTRL "textbox" 1 1 -1 475 325 625 340',0Dh,0Ah
db '        1                      ',0Dh,0Ah		     ; Transparent Bk
db '        1                      ',0Dh,0Ah		     ; Back Lit
db '        1                      ',0Dh,0Ah		     ; Back lit offset
db '        0 0 0                  ',0Dh,0Ah		     ; Back lit color
db '        "Enable Matrix effect" ',0Dh,0Ah		     ; Initial Text
db '        10                     ',0Dh,0Ah		     ; Point Size
db '        500                    ',0Dh,0Ah		     ; Weight
db '        0 255 0                ',0Dh,0Ah		     ; Bk Color
db '        255 255 255            ',0Dh,0Ah		     ; FG Color
db '        0x0                    ',0Dh,0Ah		     ; DT Flags
db '        0                      ',0Dh,0Ah		     ; Draw Border
db 0Dh,0Ah

;Matrix hotspot
db 'UICTRL "hotspot" 1 1 1669 455 325 570 340 0',0Dh,0Ah
db 0Dh,0Ah

;-----------------------
;Jumping dinos checkbox  (2nd from top)
;-----------------------
db 'UICTRL "checkbox" 1 1 1868 455 345 405 360',0Dh,0Ah
db '        "menu\\check_0.tga"       ',0Dh,0Ah
db '        "menu\\check_1.tga"       ',0Dh,0Ah
db '        "menu\\check_2.tga"       ',0Dh,0Ah
db '        "menu\\check_3.tga"       ',0Dh,0Ah
db 0Dh,0Ah

;Jumping dinos text
db 'UICTRL "textbox" 1 1 -1 475 345 625 360',0Dh,0Ah
db '        1                      ',0Dh,0Ah		     ; Transparent Bk
db '        1                      ',0Dh,0Ah		     ; Back Lit
db '        1                      ',0Dh,0Ah		     ; Back lit offset
db '        0 0 0                  ',0Dh,0Ah		     ; Back lit color
db '        "Disable jumping dinos" ',0Dh,0Ah		      ; Initial Text
db '        10                     ',0Dh,0Ah		     ; Point Size
db '        500                    ',0Dh,0Ah		     ; Weight
db '        0 255 0                ',0Dh,0Ah		     ; Bk Color
db '        255 255 255            ',0Dh,0Ah		     ; FG Color
db '        0x0                    ',0Dh,0Ah		     ; DT Flags
db '        0                      ',0Dh,0Ah		     ; Draw Border
db 0Dh,0Ah

;Jumping dinos hotspot
db 'UICTRL "hotspot" 1 1 1668 455 345 580 360 0',0Dh,0Ah
db 0Dh,0Ah

	NEW_MENU_DATA_BUFFER_END_DEMO:

;-----------------------
;Random dinos checkbox  (3rd from top)
;-----------------------
db 'UICTRL "checkbox" 1 1 1867 455 365 405 380',0Dh,0Ah
db '        "menu\\check_0.tga"       ',0Dh,0Ah
db '        "menu\\check_1.tga"       ',0Dh,0Ah
db '        "menu\\check_2.tga"       ',0Dh,0Ah
db '        "menu\\check_3.tga"       ',0Dh,0Ah
db 0Dh,0Ah

;Random dinos text
db 'UICTRL "textbox" 1 1 -1 475 365 625 425',0Dh,0Ah
db '        1                      ',0Dh,0Ah		     ; Transparent Bk
db '        1                      ',0Dh,0Ah		     ; Back Lit
db '        1                      ',0Dh,0Ah		     ; Back lit offset
db '        0 0 0                  ',0Dh,0Ah		     ; Back lit color
db '        "Enable random dinos (for certain levels only; must be disabled for some user-made levels)" ',0Dh,0Ah		  ; Initial Text
db '        10                     ',0Dh,0Ah		     ; Point Size
db '        500                    ',0Dh,0Ah		     ; Weight
db '        0 255 0                ',0Dh,0Ah		     ; Bk Color
db '        255 255 255            ',0Dh,0Ah		     ; FG Color
db '        0x10                   ',0Dh,0Ah		     ; DT Flags (DT_WORDBREAK)
db '        0                      ',0Dh,0Ah		     ; Draw Border
db 0Dh,0Ah

;Random dinos hotspot
db 'UICTRL "hotspot" 1 1 1667 455 365 590 380 0',0Dh,0Ah

db 0Dh,0Ah
	NEW_MENU_DATA_BUFFER_END:

;========================================================
NEW_RENDER_DATA_BUFFER:
db 0Dh,0Ah
db 0Dh,0Ah

;-----------------------
;draw distance text
;-----------------------
db 'UICTRL "textbox" 1 1 -1 202 201 300 219',0Dh,0Ah
db '        1                      ',0Dh,0Ah		     ; Transparent Bk
db '        1                      ',0Dh,0Ah		     ; Back Lit
db '        1                      ',0Dh,0Ah		     ; Back lit offset
db '        0 0 0                  ',0Dh,0Ah		     ; Back lit color
db '        "Draw Distance"        ',0Dh,0Ah		     ; Initial Text
db '        12                     ',0Dh,0Ah		     ; Point Size
db '        500                    ',0Dh,0Ah		     ; Weight
db '        0 255 0                ',0Dh,0Ah		     ; Bk Color
db '        255 255 255            ',0Dh,0Ah		     ; FG Color
db '        0x0                    ',0Dh,0Ah		     ; DT Flags
db '        0                      ',0Dh,0Ah		     ; Draw Border
db 0Dh,0Ah

;Gutter for draw dist. slider (background image)
db 'UICTRL "static" 1 1 -1 37 205 -1 -1',0Dh,0Ah
db '        1 "menu\\gutter_150.tga"  ',0Dh,0Ah
db 0Dh,0Ah

;Draw Distance slider (width=146, height=14)
db 'UICTRL "slider" 1 1 1794 39 200 185 214',0Dh,0Ah		;1794 -> used to ID slider
db '        "menu\\slider.tga"     ',0Dh,0Ah
db '        301                    ',0Dh,0Ah		     ; # of units
db '        '
   Default_DRAWDIST_Slider_Unit_Value:
db	   '0                      ',0Dh,0Ah		     ; Default Unit value
db '        0                      ',0Dh,0Ah		     ; Border/Ticks
db 0Dh,0Ah

db 0Dh,0Ah
NEW_RENDER_DATA_BUFFER_END:

;========================================================
GAME_DIFFICULTY_TABLE:		;4 entries per difficulty (very easy, easy, normal, hard, very hard)
	dd	  0.250000	   ;dino health multipliers (+00)
	dd	  0.750000
	dd	  1.000000
	dd	  1.500000
	dd	  2.000000

	dd	  2.000000	   ;player health multipliers (+20)
	dd	  1.300000
	dd	  1.000000
	dd	  0.700000
	dd	  0.400000

;========================================================
;TEMPORARY TEST DATA
;========================================================
compoptions:
;dd      'vids'
;dd      'mp43'
;dd      0
;dd      1
;dd      0

;dd      0
;dd      avi_bitmap_info
;dd      (avi_bitmap_info_end-avi_bitmap_info)
;dd      0
;dd      0
;dd      0


;STACKSAVE1      dd      0

AVI_BUFFER_TEMP:
;times 320*240*2         db      0

;========================================================
;VIDEO RECORDING
;========================================================

vrdef_bufsize		dd	0	;(vrdef_width*vrdef_height*3) (3 -> 24 bpp)
vrdef_frametime 	dd	0	;(1000 / vrdef_framerate = milliseconds between frames)
vrdef_frametime_INT	dd	0
vrdef_frametimediv1000	dd	0	;vrdef_frametime/1000
vrdef_dibcolors 	dd	0

dibfileheader		DIBDUMPHEADER	;includes error count
VideoStartTime		dd	0
VideoEnabledBool	db	0
NewSaveMethod		dd	0
NoLowFPSComp		dd	FALSE
newsavemethodSD 	DDSURFACEDESC2	sizeof.DDSURFACEDESC2
dx_temp_memSD		DDSURFACEDESC2	sizeof.DDSURFACEDESC2
dx_temp_mem_RECT	RECT
dx_temp_mem_DDBLTFX	DDBLTFX 	sizeof.DDBLTFX
newsavetempbuffer	dd	0
DXBLT_FIRST_RUN 	db	0

NewSaveMethod_PROCTABLE:
			dd	DoScreenCopyLoop_STD
			dd	DoScreenCopyLoop_MMX
			dd	DoScreenCopyLoop_FPU
			dd	DoScreenCopyLoop_SSE
			dd	DoScreenCopyLoop_SSE2

dibtempfile_handle	dd	0
DIBBitsPointer		dd	0
framerepeatcount_BUF	dd	0
rv_mapview_temp 	dd	0
rv_temp_dc		dd	0
rv_temp_bmp_handle	dd	0
dx_temp_mem_surface	dd	0

rv_encode_success	db	"REC: Saved as "
recvideonamebuf 	db	256 dup 0

VideoElapsedTime_STR	db	"%u sec, %u/%u frames, %u rep",0
VideoDisabled_STR	db	"Video recording disabled",0

rv_no_spec_file 	db	"REC: No valid output file specified",0
rv_error_2		db	"REC E2: Insufficient memory for max frame count",0
rv_error_3		db	"REC E3: Unable to create file mapping object",0
rv_error_4		db	"REC E4: Unable to write frame repeat table",0
rv_error_5		db	"REC E5: Unable to write DIB file header",0
rv_error_6		db	"REC E6: Unable to allocate repeat buffer memory",0
rv_error_7		db	"REC E7: Unable to create DIB dump file",0
rv_error_8		db	"REC E8: Unable to write initial header",0
rv_error_9		db	"REC E9: Unable to allocate frame buffer 2",0
rv_error_A		db	"REC EA: Invalid SaveMethod number",0

rv_error_20		db	"REC E20: CreateCompatibleDC error 0x%.8X ; total: %u",0
rv_error_21		db	"REC E21: CreateDIBSection error 0x%.8X ; total: %u",0
rv_error_22		db	"REC E22: SelectObject error 0x%.8X ; total: %u",0
rv_error_23		db	"REC E23: BitBlt error 0x%.8X ; total: %u",0
rv_error_25		db	"REC E25: WriteFile error 0x%.8X ; total: %u",0
rv_error_26		db	"REC E26: Frame Copy error ; total: %u",0
rv_error_27		db	"REC E27: DDraw Blt error ; total: %u",0
rv_error_28		db	"REC E28: Absent DDraw error 0x%.8X ; total: %u",0
rv_error_29		db	"REC E29: DDSurface create error 0x%.8X ; total: %u",0
rv_error_30		db	"REC E30: DDraw get pixel format error 0x%.8X ; total: %u",0

;MCI audio strings
mci_audio_capt_enabled	dd	0
mci_capt_in_progress	db	0
mcistr_open1		db	"open new type waveaudio alias atxreccapt buffer 4",0
mcistr_set1_str 	db	"set atxreccapt format tag pcm time format ms bitspersample %u "
			db	"channels %u samplespersec %u alignment %u bytespersec %u",0
mcistr_cue1		db	"cue atxreccapt input",0
mcistr_record1		db	"record atxreccapt overwrite",0
mcistr_stop1		db	"stop atxreccapt",0
mcistr_save1		db	"save atxreccapt "
mcistr_savename_buf	db	256 dup 0
mcistr_close1		db	"close atxreccapt",0

mci_bitspersample	dd	0
mci_channelcount	dd	0
mci_samplespersec	dd	0
mci_bytespersec 	dd	0

ValidSaveMethodsTable:
			dd	0
			dd	1
			dd	2
			dd	3
			dd	4
			dd	16
			dd	32
			dd	33
			dd	64
      ValidSaveMethodsTable_END:


;========================================================
;ATXDRV DATA
;========================================================

UseATXDRVEscKey 	dd	0
ATXDRV_AUTOREPTIME	dd	0
ATXDRV_ENABLED		dd	FALSE
ATXDRV_CURRENT		atxdrv_inst_data
ATXDRV_INITIALROTPOS	dd	8 dup 0
ATXDRV_CURRENTROTPOS	dd	8 dup 0
ATXDRV_Slowdown_BOOL	db	0	;bit 0 = straight slowdown, bit 1 = turn slowdown

;LTC = Last Tick Count
LTCStraight		dd	0
LTCSide 		dd	0

IntrCurrStraight	dd	0
IntrCurrSide		dd	0

;========================================================
;CTFRATE (test only)
;========================================================

UseTestCTFRATE_ini	dd	0
UseTestCTFRATE		db	0
UseTestCTFRATE_Count	dd	0
CTFRATE_Str		db	"CTF PROC calls per frame: %u",0

Test_Main_BOOL		dd	0

;========================================================
;Dinosaur/Vocal
;========================================================

UseNewDinoVocals	dd	0
NewDinoVocalsBuffer	dd	0

;========================================================
;KEY HANDLER DATA
;========================================================

UseKeyRateDisplay	db	0
KeyRateDisplay_STR	db	"%u WM_CHAR/sec, %u WM_KEYDOWN/sec",0
WM_CHAR_COUNT		dd	0
WM_KEYDOWN_COUNT	dd	0
WM_CHAR_COUNT_PREV	dd	0
WM_KEYDOWN_COUNT_PREV	dd	0
KeyRate_Time		dd	0





