;============================================================
;in-game error logging
;============================================================
DisplayErrorCount:
cmp [RT_ERROR_COUNT],0
    jz NoLastErrorCountDisplay

push ebp
mov ebp,esp
sub esp,100

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	lea ebx,[ebp-100]

invoke sprintf,ebx,ErrorCountDisplayString,[RT_ERROR_COUNT]
	add esp,12

invoke TextOut,edi,0,ERROR_LOG_MSG_VERT,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

invoke GetTickCount
       sub eax,[LAST_ERROR_TIME]
       cmp eax,4000
	   jb NoChangeLastErrorTime
       and [LAST_ERROR_TIME],0
       NoChangeLastErrorTime:

mov esp,ebp
pop ebp
NoLastErrorCountDisplay:
ret

;============================================================
WriteATXInGameError:	;[esp+4]=error string , [esp+8]=address
;============================================================
push ebp
mov ebp,esp
sub esp,200
push eax
push ecx
push edx
push ebx
push edi

	inc [RT_ERROR_COUNT]
invoke GetTickCount
	mov [LAST_ERROR_TIME],eax

invoke CreateFile,LogFileName,GENERIC_WRITE,0,0,OPEN_ALWAYS,\
	FILE_ATTRIBUTE_NORMAL,0
	mov ebx,eax
	test eax,eax
	     jz Exit_WriteATXInGameError
invoke SetFilePointer,eax,0,0,FILE_END

	lea edx,[ebp-200]
invoke wsprintf,edx,_ingameerrorstringmain,[RT_ERROR_COUNT],[ebp+8],[ebp+12]
	add esp,20

	lea ecx,[ebp-4]
	lea edx,[ebp-200]
invoke WriteFile,ebx,edx,eax,ecx,0

invoke CloseHandle,ebx

Exit_WriteATXInGameError:
pop edi
pop ebx
pop edx
pop ecx
pop eax
mov esp,ebp
pop ebp
ret 8
;============================================================

