;============================================================
;displays FPS (.5 second interval)
;============================================================
DisplayFPS:
push ebp
mov ebp,esp
sub esp,100
       mov eax,[BaseDDSurfaceADDR]
       mov ecx,[eax]
       call [EXEPROC_GETDDSURFDC]      ;GetDC for DDraw surface via EXE
       mov edi,eax

invoke GetTickCount
       mov ecx,eax
       sub eax,[FPS_lastframetime]
       cmp eax,500
	   jb NoChangeFPSvalue

       push eax
       mov [FPS_lastframetime],ecx
       fild [FPS_framecount]
       fild DWORD [esp]
       fdivp st1,st0
       and [FPS_framecount],0
       fmul [float_1000]
       add esp,4
       fstp QWORD [FPS_lastfps]
       NoChangeFPSvalue:

       inc [FPS_framecount]

       lea ebx,[ebp-100]
invoke sprintf,ebx,FPS_string,DWORD [FPS_lastfps],DWORD [FPS_lastfps+4]
       add esp,16

invoke TextOut,edi,0,FPS_MSG,ebx,eax

       mov eax,[BaseDDSurfaceADDR]
       push edi 		;DDraw ReleaseDC
       mov ecx,[eax]
       call [EXEPROC_RELEASEDDSURFDC]

mov esp,ebp
pop ebp
ret