;============================================================
;displays some arbitrary "player" class values (undocumented FAC cheat)
;============================================================
DisplayPlayerFaceFloats:
push ebp
push esi
mov ebp,esp
sub esp,150

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	mov edx,[LocationADDR]
	mov edx,[edx]
	mov esi,[edx+14h]
	lea ebx,[ebp-150]
	sub esp,32

	fld DWORD [esi+3Ch]
	fstp QWORD [esp]
	fld DWORD [esi+40h]
	fstp QWORD [esp+8]
	fld DWORD [esi+44h]
	fstp QWORD [esp+16]
	fld DWORD [esi+48h]
	fstp QWORD [esp+24]

invoke sprintf,ebx,ShowFaceFloat_STRING
	add esp,40

invoke TextOut,edi,0,FACE_FLOATS_MSG,ebx,eax

	lea eax,[esi+3Ch]
	lea ecx,[ebp-16]
	call QuatToAxisAngle

	sub esp,32
	fld DWORD [ebp-16]
	fstp QWORD [esp]
	fld DWORD [ebp-12]
	fstp QWORD [esp+8]
	fld DWORD [ebp-8]
	fstp QWORD [esp+16]
	fld DWORD [ebp-4]
	fstp QWORD [esp+24]
invoke sprintf,ebx,ShowFaceFloat_AA_STRING
	add esp,40
invoke TextOut,edi,0,FACE_FLOATS_MSG+10h,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

mov esp,ebp
pop esi
pop ebp
ret

;============================================================
;displays Player HitPoints and MaxHitPoints values
;============================================================
DisplayPlayerHealth:

cmp [ShowPlayerHealth_BOOL],0
    jnz DisplayPlayerHealth_345
	ret

DisplayPlayerHealth_345:
push ebp
mov ebp,esp
sub esp,100

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]			;edx='player' object

	fld DWORD [edx+50h]
	fld DWORD [edx+54h]

	sub esp,16
	lea ebx,[ebp-100]

	fstp QWORD [esp+8]
	fstp QWORD [esp]

invoke sprintf,ebx,ShowPlayerHealth_STRING
	add esp,24

invoke TextOut,edi,0,PLAYERHEALTH_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

mov esp,ebp
pop ebp
ret

;============================================================
;Display CONVERT_TO_FACING_PROC number of calls per frame
;============================================================
DisplayCONVTOFACINGPop:
push ebp
mov ebp,esp
sub esp,150

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax
	lea ebx,[ebp-150]

invoke sprintf,ebx,CTFRATE_Str,[UseTestCTFRATE_Count]
	add esp,12
	mov [UseTestCTFRATE_Count],0

invoke TextOut,edi,0,FACE_FLOATS_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

mov esp,ebp
pop ebp
ret

;============================================================
;Displays WM_KEYDOWN and WM_CHAR messages' frequencies
;============================================================
DisplayKeyRate:
push ebp
mov ebp,esp
sub esp,150

	invoke GetTickCount
	sub eax,[KeyRate_Time]
	cmp eax,1000
	    jb NoSetNewKeyRateValues
	       add [KeyRate_Time],eax
	       xor edx,edx
	       mov eax,[WM_CHAR_COUNT]
	       mov [WM_CHAR_COUNT_PREV],eax
	       mov eax,[WM_KEYDOWN_COUNT]
	       mov [WM_KEYDOWN_COUNT_PREV],eax
	       mov [WM_CHAR_COUNT],edx
	       mov [WM_KEYDOWN_COUNT],edx
	NoSetNewKeyRateValues:

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax
	lea ebx,[ebp-150]


invoke sprintf,ebx,KeyRateDisplay_STR,[WM_CHAR_COUNT_PREV],[WM_KEYDOWN_COUNT_PREV]
	add esp,16

invoke TextOut,edi,0,FACE_FLOATS_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

mov esp,ebp
pop ebp
ret

